[![AtlasKit component registry](https://img.shields.io/badge/AtlasKit-components-FF5230.svg)](http://atlaskit.atlassian.com)
[![Commitizen friendly](https://img.shields.io/badge/commitizen-friendly-brightgreen.svg)](http://Commitizen.github.io/cz-cli/)
[![semantic-release](https://img.shields.io/badge/GitHub-semantic_release-ffab00.svg)](https://github.com/semantic-release/semantic-release)
[![Report an issue](https://img.shields.io/badge/Report-an_issue-6554C0.svg)](http://go.atlassian.com/atlaskit-issues)

# Spotlight

The spotlight component is used typically during onboarding to highlight elements
of the UI to the user in a modal dialog.

## Example

```js
import { Spotlight, SpotlightManager, SpotlightTarget } from '@atlaskit/spotlight';

class MyClass extends Component {
  render() {
    return (
      <SpotlightManager>
        <div>
          <SpotlightTarget name="foo">
            <span>bar</span>
          </SpotlightTarget>
          <Spotlight target="foo">
            <span>baz</span>
          </Spotlight>
        </div>
      </SpotlightManager>
    );
  }
}
```

## Try it out

Interact with a [live demo of the @atlaskit/spotlight component](https://aui-cdn.atlassian.com/atlaskit/stories/@atlaskit/spotlight/1.1.1/).

## Installation

```sh
npm install @atlaskit/spotlight
```

_* Please note that this module could have dependencies that are governed by the Atlassian Design Guidelines license which will be automatically included on install. Each dependency has a license file that indicates whether the Atlassian Design Guidelines license applies._

## We're here to help!

Let us know what you think of our components and docs, your feedback is really important for us.

Are you in trouble? Read through our [contribution guidelines](https://bitbucket.org/atlassian/atlaskit/src/HEAD/CONTRIBUTING.md) and raise an issue to us.

