import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import _PropTypes from 'prop-types';
import React, { PureComponent } from 'react';
import PropTypes from 'prop-types';
import { ScrollLock } from '@atlaskit/layer-manager';

import SpotlightRegistry from './SpotlightRegistry';

import Blanket from '../styled/Blanket';

var SpotlightManager = function (_PureComponent) {
  _inherits(SpotlightManager, _PureComponent);

  /* eslint-enable react/sort-comp */

  function SpotlightManager(props, context) {
    _classCallCheck(this, SpotlightManager);

    var _this = _possibleConstructorReturn(this, _PureComponent.call(this, props, context));

    _this.state = { mounted: 0 };

    _this.handleMount = function () {
      return _this.setState(function (state) {
        return { mounted: state.mounted + 1 };
      });
    };

    _this.handleUnmount = function () {
      return _this.setState(function (state) {
        return { mounted: state.mounted - 1 };
      });
    };

    _this.spotlightRegistry = new SpotlightRegistry();
    return _this;
  }

  /* eslint-disable react/sort-comp */


  SpotlightManager.prototype.getChildContext = function getChildContext() {
    return {
      spotlightRegistry: this.spotlightRegistry
    };
  };

  SpotlightManager.prototype.componentWillMount = function componentWillMount() {
    this.spotlightRegistry.addChangeListener('mount', this.handleMount);
    this.spotlightRegistry.addChangeListener('unmount', this.handleUnmount);
  };

  SpotlightManager.prototype.componentWillUnmount = function componentWillUnmount() {
    this.spotlightRegistry.removeChangeListener('mount', this.handleMount);
    this.spotlightRegistry.removeChangeListener('unmount', this.handleUnmount);
  };

  SpotlightManager.prototype.render = function render() {
    var _props = this.props,
        children = _props.children,
        Tag = _props.component;
    var mounted = this.state.mounted;

    var dialogIsVisible = Boolean(mounted);

    return React.createElement(
      Tag,
      null,
      children,
      dialogIsVisible && React.createElement(Blanket, null),
      dialogIsVisible && React.createElement(ScrollLock, null)
    );
  };

  return SpotlightManager;
}(PureComponent);

SpotlightManager.childContextTypes = {
  spotlightRegistry: PropTypes.instanceOf(SpotlightRegistry).isRequired
};
SpotlightManager.defaultProps = {
  component: 'div'
};
SpotlightManager.propTypes = {
  children: _PropTypes.any.isRequired,
  component: _PropTypes.any.isRequired
};
export default SpotlightManager;