import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import _PropTypes from 'prop-types';
import PropTypes from 'prop-types';
import { Children, Component } from 'react';
import { findDOMNode } from 'react-dom';

import SpotlightRegistry from './SpotlightRegistry';

var errorMessage = '`SpotlightTarget` requires `SpotlightManager` as an ancestor.';

var SpotlightTarget = function (_Component) {
  _inherits(SpotlightTarget, _Component);

  function SpotlightTarget() {
    _classCallCheck(this, SpotlightTarget);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  // eslint-disable-line react/sort-comp
  SpotlightTarget.prototype.componentDidMount = function componentDidMount() {
    var name = this.props.name;
    var spotlightRegistry = this.context.spotlightRegistry;


    if (!spotlightRegistry) {
      throw Error(errorMessage);
    } else {
      spotlightRegistry.add(name, findDOMNode(this));
    }
  };

  SpotlightTarget.prototype.componentWillUnmount = function componentWillUnmount() {
    var name = this.props.name;
    var spotlightRegistry = this.context.spotlightRegistry;


    if (!spotlightRegistry) {
      throw Error(errorMessage);
    } else {
      spotlightRegistry.remove(name);
    }
  };

  SpotlightTarget.prototype.render = function render() {
    return Children.only(this.props.children);
  };

  return SpotlightTarget;
}(Component);

SpotlightTarget.propTypes = {
  /** a single child */
  children: _PropTypes.any.isRequired /** the name to reference from Spotlight */
  ,
  name: _PropTypes.string.isRequired
};
SpotlightTarget.contextTypes = {
  spotlightRegistry: PropTypes.instanceOf(SpotlightRegistry).isRequired
};
export default SpotlightTarget;