import _extends from 'babel-runtime/helpers/extends';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';

/* eslint-disable react/sort-comp, react/no-multi-comp */
import React, { Component } from 'react';
import PropTypes from 'prop-types';

import SpotlightRegistry from '../components/SpotlightRegistry';

function getScrollY() {
  return window.pageYOffset || document.documentElement.scrollTop || document.body.scrollTop || 0;
}
function getInitialState() {
  return {
    scrollY: getScrollY()
  };
}

var withScrollMeasurementsId = 0;

export default function withScrollMeasurements(WrappedComponent) {
  var _class, _temp2;

  return _temp2 = _class = function (_Component) {
    _inherits(SpotlightWrapper, _Component);

    function SpotlightWrapper() {
      var _temp, _this, _ret;

      _classCallCheck(this, SpotlightWrapper);

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = getInitialState(), _this.measureAndScroll = function (node) {
        var _node$getBoundingClie = node.getBoundingClientRect(),
            height = _node$getBoundingClie.height,
            left = _node$getBoundingClie.left,
            initialTop = _node$getBoundingClie.top,
            width = _node$getBoundingClie.width;

        var scrollY = _this.state.scrollY;

        var gutter = 10; // enough room to be comfortable and not crop the pulse animation

        var top = initialTop;

        // hidden above viewport
        if (initialTop < 0) {
          top = gutter;
          window.scrollTo(0, scrollY + (initialTop - gutter));

          // hidden below viewport
        } else if (initialTop + height > scrollY + window.innerHeight) {
          top = gutter;
          window.scrollTo(0, initialTop + scrollY - gutter);
        }

        // get adjusted measurements after scrolling
        _this.setState({
          clone: node.outerHTML,
          rect: { height: height, left: left, top: top, width: width },
          scrollY: getScrollY()
        });
      }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    SpotlightWrapper.prototype.componentWillMount = function componentWillMount() {
      // NOTE: we don't document the spotlightRegistry prop type because it
      // is provided by the HOC and not part of the public API.
      // eslint-disable-next-line react/prop-types
      var target = this.props.target;
      var spotlightRegistry = this.context.spotlightRegistry;


      if (!spotlightRegistry) {
        throw Error('`Spotlight` requires `SpotlightManager` as an ancestor.');
      }

      spotlightRegistry.mount(target || 'no_target_' + ++withScrollMeasurementsId);

      if (target) {
        var node = spotlightRegistry.get(target);
        this.measureAndScroll(node);
      }
    };

    SpotlightWrapper.prototype.componentWillUnmount = function componentWillUnmount() {
      // eslint-disable-next-line react/prop-types
      var target = this.props.target;
      var spotlightRegistry = this.context.spotlightRegistry;


      spotlightRegistry.unmount(target || 'no_target_' + withScrollMeasurementsId);
    };

    SpotlightWrapper.prototype.render = function render() {
      return React.createElement(WrappedComponent, _extends({}, this.state, this.props, this.context));
    };

    return SpotlightWrapper;
  }(Component), _class.contextTypes = {
    spotlightRegistry: PropTypes.instanceOf(SpotlightRegistry).isRequired
  }, _temp2;
}