import _taggedTemplateLiteral from 'babel-runtime/helpers/taggedTemplateLiteral';

var _templateObject = _taggedTemplateLiteral(['', 'px'], ['', 'px']),
    _templateObject2 = _taggedTemplateLiteral(['\n  height: 100%;\n  left: 0;\n  overflow-y: auto;\n  position: absolute;\n  top: ', 'px;\n  width: 100%;\n'], ['\n  height: 100%;\n  left: 0;\n  overflow-y: auto;\n  position: absolute;\n  top: ', 'px;\n  width: 100%;\n']),
    _templateObject3 = _taggedTemplateLiteral(['\n  margin: ', 'px auto;\n  position: relative;\n  width: ', ';\n  z-index: ', ';\n'], ['\n  margin: ', 'px auto;\n  position: relative;\n  width: ', ';\n  z-index: ', ';\n']),
    _templateObject4 = _taggedTemplateLiteral(['\n  background: ', ';\n  border-radius: ', 'px;\n  box-shadow: ', ';\n  box-sizing: border-box;\n  color: ', ';\n  display: flex;\n  flex-direction: column;\n  width: ', ';\n  z-index: ', ';\n'], ['\n  background: ', ';\n  border-radius: ', 'px;\n  box-shadow: ', ';\n  box-sizing: border-box;\n  color: ', ';\n  display: flex;\n  flex-direction: column;\n  width: ', ';\n  z-index: ', ';\n']),
    _templateObject5 = _taggedTemplateLiteral(['\n  flex: 1 1 auto;\n  padding: ', 'px ', 'px;\n'], ['\n  flex: 1 1 auto;\n  padding: ', 'px ', 'px;\n']);

import styled, { css } from 'styled-components';
import { borderRadius, colors, gridSize, layers, math, themed } from '@atlaskit/theme';

export var DIALOG_WIDTH = {
  small: 400,
  medium: 600
};
var gutter = 60;
var dialogWidth = function dialogWidth(p) {
  var widthValue = DIALOG_WIDTH[p.size] || p.size;
  return css(_templateObject, widthValue);
};

var backgroundColor = function backgroundColor(props) {
  return props.appearance === 'help' ? colors.P300 : themed({
    light: colors.N0,
    dark: colors.DN50
  });
};
var textColor = function textColor(props) {
  return props.appearance === 'help' ? colors.N0 : colors.text;
};
var borderColor = themed({
  light: colors.N60A,
  dark: colors.DN60A
});
var shadowColor = themed({
  light: colors.N50A,
  dark: colors.DN50A
});

var getBoxShadow = function getBoxShadow(props) {
  var border = '0 0 1px ' + borderColor(props);
  var shadow = '0 4px 8px -2px ' + shadowColor(props);

  return [border, shadow].join(',');
};

export var FillScreen = styled.div(_templateObject2, function (p) {
  return p.scrollDistance;
});

export var DialogPositioner = styled.div(_templateObject3, gutter, dialogWidth, layers.spotlight);

export var Dialog = styled.div(_templateObject4, backgroundColor, borderRadius, getBoxShadow, textColor, dialogWidth, layers.spotlight);
export var DialogBody = styled.div(_templateObject5, math.multiply(gridSize, 2), math.multiply(gridSize, 3));